package main;

/**
 * This interface is used to implement a visitor pattern
 * in other classes. For more information:
 * <a href=https://en.wikipedia.org/wiki/Visitor_pattern>Visitor Pattern</a>
 */
public interface Visitor<T>{
    public T visit(final Parser.BinaryOperation binOp);
    public T visit(final Parser.Variable variable);
    public T visit(final Parser.Number number);
    public T visit(final Parser.Decimal decimal);
}
