package test;

import main.Evaluator;
import main.Lexer;
import main.Parser;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.assertEquals;

public class EvaluatorTest {

    @Test
    public void testWithString1() {
        String s = "1 + (x^2) - (3*x)";
        var parser = new Parser();
        var evaluator = new Evaluator();
        try {
            var tokens = Lexer.lex(s);
            var ast = parser.parse(tokens);
            var value = evaluator.visit(ast, 5);
            assertEquals(value,11);
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Test
    public void testWithString2() {
        String s = "(2*x)+(0.5*x^2)-1";
        var parser = new Parser();
        var evaluator = new Evaluator();
        try {
            var tokens = Lexer.lex(s);
            var ast = parser.parse(tokens);
            var value = evaluator.visit(ast, 8);
            assertEquals(value,47);
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Test
    public void testWithString3() {
        String s = "(x^2)-40";
        var parser = new Parser();
        var evaluator = new Evaluator();
        try {
            var tokens = Lexer.lex(s);
            var ast = parser.parse(tokens);
            var value = evaluator.visit(ast, 4);
            assertEquals(value,-24);
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }
}
