package test;

import org.junit.Test;
import main.*;

import java.util.LinkedList;
import java.util.List;

import static org.junit.Assert.assertThat;
import static org.junit.jupiter.api.Assertions.*;

 public class LexerTest {

    @Test
    public void disassembleFirstStringWithLexer() {
        String s = "3+x*(2^4)";
        List<Lexer.Token> tokens = new LinkedList<>();
        tokens.add(new Lexer.Token(Lexer.TokenType.NUMBER,"3"));
        tokens.add(new Lexer.Token(Lexer.TokenType.SPECIAL,"+"));
        tokens.add(new Lexer.Token(Lexer.TokenType.VARIABLE,"x"));
        tokens.add(new Lexer.Token(Lexer.TokenType.SPECIAL,"*"));
        tokens.add(new Lexer.Token(Lexer.TokenType.SPECIAL,"("));
        tokens.add(new Lexer.Token(Lexer.TokenType.NUMBER,"2"));
        tokens.add(new Lexer.Token(Lexer.TokenType.SPECIAL,"^"));
        tokens.add(new Lexer.Token(Lexer.TokenType.NUMBER,"4"));
        tokens.add(new Lexer.Token(Lexer.TokenType.SPECIAL,")"));
        try {
            assertEquals(Lexer.lex(s),tokens);
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }

    @Test
    public void disassembleSecondStringWithLexer() {
        String s = "1 + (x^2 )- (3*x)";
        List<Lexer.Token> tokens = new LinkedList<>();
        tokens.add(new Lexer.Token(Lexer.TokenType.NUMBER,"1"));
        tokens.add(new Lexer.Token(Lexer.TokenType.SPECIAL,"+"));
        tokens.add(new Lexer.Token(Lexer.TokenType.SPECIAL,"("));
        tokens.add(new Lexer.Token(Lexer.TokenType.VARIABLE,"x"));
        tokens.add(new Lexer.Token(Lexer.TokenType.SPECIAL,"^"));
        tokens.add(new Lexer.Token(Lexer.TokenType.NUMBER,"2"));
        tokens.add(new Lexer.Token(Lexer.TokenType.SPECIAL,")"));
        tokens.add(new Lexer.Token(Lexer.TokenType.SPECIAL,"-"));
        tokens.add(new Lexer.Token(Lexer.TokenType.SPECIAL,"("));
        tokens.add(new Lexer.Token(Lexer.TokenType.NUMBER,"3"));
        tokens.add(new Lexer.Token(Lexer.TokenType.SPECIAL,"*"));
        tokens.add(new Lexer.Token(Lexer.TokenType.VARIABLE,"x"));
        tokens.add(new Lexer.Token(Lexer.TokenType.SPECIAL,")"));
        try {
            assertEquals(Lexer.lex(s),tokens);
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }
}